
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Playlist_placementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const playlist_placements = await db.playlist_placements.create(
            {
                id: data.id || undefined,
        
        placed_at: data.placed_at
        ||
        null
            ,
            
        removed_at: data.removed_at
        ||
        null
            ,
            
        position: data.position
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await playlist_placements.setTrack( data.track || null, {
            transaction,
        });
        
        await playlist_placements.setPlaylist( data.playlist || null, {
            transaction,
        });
        
        await playlist_placements.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return playlist_placements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const playlist_placementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                placed_at: item.placed_at
            ||
            null
            ,
            
                removed_at: item.removed_at
            ||
            null
            ,
            
                position: item.position
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const playlist_placements = await db.playlist_placements.bulkCreate(playlist_placementsData, { transaction });

        // For each item created, replace relation files
        

        return playlist_placements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const playlist_placements = await db.playlist_placements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.placed_at !== undefined) updatePayload.placed_at = data.placed_at;
        
        
        if (data.removed_at !== undefined) updatePayload.removed_at = data.removed_at;
        
        
        if (data.position !== undefined) updatePayload.position = data.position;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await playlist_placements.update(updatePayload, {transaction});

        
        
        if (data.track !== undefined) {
            await playlist_placements.setTrack(
              
              data.track,
              
              { transaction }
            );
        }
        
        if (data.playlist !== undefined) {
            await playlist_placements.setPlaylist(
              
              data.playlist,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await playlist_placements.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return playlist_placements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const playlist_placements = await db.playlist_placements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of playlist_placements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of playlist_placements) {
                await record.destroy({transaction});
            }
        });


        return playlist_placements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const playlist_placements = await db.playlist_placements.findByPk(id, options);

        await playlist_placements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await playlist_placements.destroy({
            transaction
        });

        return playlist_placements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const playlist_placements = await db.playlist_placements.findOne(
            { where },
            { transaction },
        );

        if (!playlist_placements) {
            return playlist_placements;
        }

        const output = playlist_placements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.track = await playlist_placements.getTrack({
            transaction
        });
        
        
        output.playlist = await playlist_placements.getPlaylist({
            transaction
        });
        
        
        output.organizations = await playlist_placements.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.tracks,
        as: 'track',
        
        where: filter.track ? {
          [Op.or]: [
            { id: { [Op.in]: filter.track.split('|').map(term => Utils.uuid(term)) } },
            {
              title: {
                [Op.or]: filter.track.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.playlists,
        as: 'playlist',
        
        where: filter.playlist ? {
          [Op.or]: [
            { id: { [Op.in]: filter.playlist.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.playlist.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'playlist_placements',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            placed_at: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    removed_at: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.placed_atRange) {
                const [start, end] = filter.placed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    placed_at: {
                    ...where.placed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    placed_at: {
                    ...where.placed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.removed_atRange) {
                const [start, end] = filter.removed_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    removed_at: {
                    ...where.removed_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    removed_at: {
                    ...where.removed_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.positionRange) {
                const [start, end] = filter.positionRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    position: {
                    ...where.position,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    position: {
                    ...where.position,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.playlist_placements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'playlist_placements',
                        'notes',
                        query,
                    ),
                ],
            };
        }

        const records = await db.playlist_placements.findAll({
            attributes: [ 'id', 'notes' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['notes', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.notes,
        }));
    }

    
};

